package com.yingxin.beijingvehicleflow.service.impl;

import com.yingxin.beijingvehicleflow.entity.FloatingPopulation;
import com.yingxin.beijingvehicleflow.mapper.FloatingPopulationMapper;
import com.yingxin.beijingvehicleflow.service.FloatingPopulationServcie;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * description //TODO
 *
 * @author 226
 * @version 1.0
 * @date 2020/2/24
 */
@Service
public class FloatingPopulationServcieImpl implements FloatingPopulationServcie {

    private static Logger LOGGER = LoggerFactory.getLogger(FloatingPopulationServcie.class);

    @Autowired
    private FloatingPopulationMapper populationMapper;

    @Value("${QR-code-validTime}")
    private long validTime;

    @Override
    public boolean isInsertFloatingPopulationSucc(FloatingPopulation floatingPopulation) {
        return populationMapper.insertFloatingPopulation(floatingPopulation) == 1;
    }

    @Override
    public boolean isIdentityInfoValid(FloatingPopulation floatingPopulation) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String authTime = floatingPopulation.getAuthTime();
        String checkTime = sdf.format(new Date());
        long milliSeconds;
        try {
            Date authDate = sdf.parse(authTime);
            Date checkDate = sdf.parse(checkTime);
            milliSeconds = checkDate.getTime() - authDate.getTime();

        } catch (ParseException e) {
            LOGGER.error("检验二维码是否过期日期解析异常", e);
            return false;
        }

        return (milliSeconds/60.0/1000.0) < validTime;
    }

    @Override
    public FloatingPopulation selectOneByReservationId(FloatingPopulation floatingPopulation) {
        return populationMapper.selectOneByReservationId(floatingPopulation);
    }
}
